Index: palm/trunk/SOURCE/advec_particles.f90
===================================================================
--- palm/trunk/SOURCE/advec_particles.f90	(revision 56)
+++ palm/trunk/SOURCE/advec_particles.f90	(revision 57)
@@ -967,107 +901,706 @@
              k = ( particles(n)%z + 0.5 * dz ) / dz  ! only exact if eq.dist
 
-             x  = particles(n)%x - i * dx
-             y  = particles(n)%y - j * dy
-             aa = x**2          + y**2
-             bb = ( dx - x )**2 + y**2
-             cc = x**2          + ( dy - y )**2
-             dd = ( dx - x )**2 + ( dy - y )**2
-             gg = aa + bb + cc + dd
-
-             e_int_l = ( ( gg-aa ) * e(k,j,i)   + ( gg-bb ) * e(k,j,i+1)   &
-                       + ( gg-cc ) * e(k,j+1,i) + ( gg-dd ) * e(k,j+1,i+1) &
-                       ) / ( 3.0 * gg )
-
-             IF ( k+1 == nzt+1 )  THEN
-                e_int = e_int_l
+             IF ( topography == 'flat' )  THEN        
+
+                x  = particles(n)%x - i * dx
+                y  = particles(n)%y - j * dy
+                aa = x**2          + y**2
+                bb = ( dx - x )**2 + y**2
+                cc = x**2          + ( dy - y )**2
+                dd = ( dx - x )**2 + ( dy - y )**2
+                gg = aa + bb + cc + dd
+
+                e_int_l = ( ( gg-aa ) * e(k,j,i)   + ( gg-bb ) * e(k,j,i+1)   &
+                          + ( gg-cc ) * e(k,j+1,i) + ( gg-dd ) * e(k,j+1,i+1) &
+                          ) / ( 3.0 * gg )
+
+                IF ( k+1 == nzt+1 )  THEN
+                   e_int = e_int_l
+                ELSE
+                   e_int_u = ( ( gg - aa ) * e(k+1,j,i)   + &
+                               ( gg - bb ) * e(k+1,j,i+1) + &
+                               ( gg - cc ) * e(k+1,j+1,i) + &
+                               ( gg - dd ) * e(k+1,j+1,i+1) &
+                             ) / ( 3.0 * gg )
+                   e_int = e_int_l + ( particles(n)%z - zu(k) ) / dz * &
+                                     ( e_int_u - e_int_l )
+                ENDIF
+
+!
+!--             Interpolate the TKE gradient along x (adopt incides i,j,k and
+!--             all position variables from above (TKE))
+                de_dx_int_l = ( ( gg - aa ) * de_dx(k,j,i)   + &
+                                ( gg - bb ) * de_dx(k,j,i+1) + &
+                                ( gg - cc ) * de_dx(k,j+1,i) + &
+                                ( gg - dd ) * de_dx(k,j+1,i+1) &
+                              ) / ( 3.0 * gg )
+
+                IF ( ( k+1 == nzt+1 )  .OR.  ( k == nzb ) )  THEN
+                   de_dx_int = de_dx_int_l
+                ELSE
+                   de_dx_int_u = ( ( gg - aa ) * de_dx(k+1,j,i)   + &
+                                   ( gg - bb ) * de_dx(k+1,j,i+1) + &
+                                   ( gg - cc ) * de_dx(k+1,j+1,i) + &
+                                   ( gg - dd ) * de_dx(k+1,j+1,i+1) &
+                                 ) / ( 3.0 * gg )
+                   de_dx_int = de_dx_int_l + ( particles(n)%z - zu(k) ) / dz * &
+                                             ( de_dx_int_u - de_dx_int_l )
+                ENDIF
+
+!
+!--             Interpolate the TKE gradient along y
+                de_dy_int_l = ( ( gg - aa ) * de_dy(k,j,i)   + &
+                                ( gg - bb ) * de_dy(k,j,i+1) + &
+                                ( gg - cc ) * de_dy(k,j+1,i) + &
+                                ( gg - dd ) * de_dy(k,j+1,i+1) &
+                              ) / ( 3.0 * gg )
+                IF ( ( k+1 == nzt+1 )  .OR.  ( k == nzb ) )  THEN
+                   de_dy_int = de_dy_int_l
+                ELSE
+                   de_dy_int_u = ( ( gg - aa ) * de_dy(k+1,j,i)   + &
+                                   ( gg - bb ) * de_dy(k+1,j,i+1) + &
+                                   ( gg - cc ) * de_dy(k+1,j+1,i) + &
+                                   ( gg - dd ) * de_dy(k+1,j+1,i+1) &
+                                 ) / ( 3.0 * gg )
+                   de_dy_int = de_dy_int_l + ( particles(n)%z - zu(k) ) / dz * &
+                                             ( de_dy_int_u - de_dy_int_l )
+                ENDIF
+
+!
+!--             Interpolate the TKE gradient along z
+                IF ( particles(n)%z < 0.5 * dz ) THEN
+                   de_dz_int = 0.0
+                ELSE
+                   de_dz_int_l = ( ( gg - aa ) * de_dz(k,j,i)   + &
+                                   ( gg - bb ) * de_dz(k,j,i+1) + &
+                                   ( gg - cc ) * de_dz(k,j+1,i) + &
+                                   ( gg - dd ) * de_dz(k,j+1,i+1) &
+                                 ) / ( 3.0 * gg )
+
+                   IF ( ( k+1 == nzt+1 )  .OR.  ( k == nzb ) )  THEN
+                      de_dz_int = de_dz_int_l
+                   ELSE
+                      de_dz_int_u = ( ( gg - aa ) * de_dz(k+1,j,i)   + &
+                                      ( gg - bb ) * de_dz(k+1,j,i+1) + &
+                                      ( gg - cc ) * de_dz(k+1,j+1,i) + &
+                                      ( gg - dd ) * de_dz(k+1,j+1,i+1) &
+                                    ) / ( 3.0 * gg )
+                      de_dz_int = de_dz_int_l + ( particles(n)%z - zu(k) ) / dz * &
+                                                ( de_dz_int_u - de_dz_int_l )
+                   ENDIF
+                ENDIF
+
+!
+!--             Interpolate the dissipation of TKE
+                diss_int_l = ( ( gg - aa ) * diss(k,j,i)   + &
+                               ( gg - bb ) * diss(k,j,i+1) + &
+                               ( gg - cc ) * diss(k,j+1,i) + &
+                               ( gg - dd ) * diss(k,j+1,i+1) &
+                              ) / ( 3.0 * gg )
+
+                IF ( k+1 == nzt+1 )  THEN
+                   diss_int = diss_int_l
+                ELSE
+                   diss_int_u = ( ( gg - aa ) * diss(k+1,j,i)   + &
+                                  ( gg - bb ) * diss(k+1,j,i+1) + &
+                                  ( gg - cc ) * diss(k+1,j+1,i) + &
+                                  ( gg - dd ) * diss(k+1,j+1,i+1) &
+                                 ) / ( 3.0 * gg )
+                   diss_int = diss_int_l + ( particles(n)%z - zu(k) ) / dz * &
+                                           ( diss_int_u - diss_int_l )
+                ENDIF
+
              ELSE
-                e_int_u = ( ( gg - aa ) * e(k+1,j,i)   + &
-                            ( gg - bb ) * e(k+1,j,i+1) + &
-                            ( gg - cc ) * e(k+1,j+1,i) + &
-                            ( gg - dd ) * e(k+1,j+1,i+1) &
-                          ) / ( 3.0 * gg )
-                e_int = e_int_l + ( particles(n)%z - zu(k) ) / dz * &
-                                  ( e_int_u - e_int_l )
-             ENDIF
-
-!
-!--          Interpolate the TKE gradient along x (adopt incides i,j,k and all
-!--          position variables from above (TKE))
-             de_dx_int_l = ( ( gg - aa ) * de_dx(k,j,i)   + &
-                             ( gg - bb ) * de_dx(k,j,i+1) + &
-                             ( gg - cc ) * de_dx(k,j+1,i) + &
-                             ( gg - dd ) * de_dx(k,j+1,i+1) &
-                           ) / ( 3.0 * gg )
-
-             IF ( ( k+1 == nzt+1 )  .OR.  ( k == nzb ) )  THEN
-                de_dx_int = de_dx_int_l
-             ELSE
-                de_dx_int_u = ( ( gg - aa ) * de_dx(k+1,j,i)   + &
-                                ( gg - bb ) * de_dx(k+1,j,i+1) + &
-                                ( gg - cc ) * de_dx(k+1,j+1,i) + &
-                                ( gg - dd ) * de_dx(k+1,j+1,i+1) &
-                              ) / ( 3.0 * gg )
-                de_dx_int = de_dx_int_l + ( particles(n)%z - zu(k) ) / dz * &
-                                          ( de_dx_int_u - de_dx_int_l )
-             ENDIF
-
-!
-!--          Interpolate the TKE gradient along y
-             de_dy_int_l = ( ( gg - aa ) * de_dy(k,j,i)   + &
-                             ( gg - bb ) * de_dy(k,j,i+1) + &
-                             ( gg - cc ) * de_dy(k,j+1,i) + &
-                             ( gg - dd ) * de_dy(k,j+1,i+1) &
-                           ) / ( 3.0 * gg )
-             IF ( ( k+1 == nzt+1 )  .OR.  ( k == nzb ) )  THEN
-                de_dy_int = de_dy_int_l
-             ELSE
-                de_dy_int_u = ( ( gg - aa ) * de_dy(k+1,j,i)   + &
-                                ( gg - bb ) * de_dy(k+1,j,i+1) + &
-                                ( gg - cc ) * de_dy(k+1,j+1,i) + &
-                                ( gg - dd ) * de_dy(k+1,j+1,i+1) &
-                              ) / ( 3.0 * gg )
-                de_dy_int = de_dy_int_l + ( particles(n)%z - zu(k) ) / dz * &
-                                          ( de_dy_int_u - de_dy_int_l )
-             ENDIF
-
-!
-!--          Interpolate the TKE gradient along z
-             de_dz_int_l = ( ( gg - aa ) * de_dz(k,j,i)   + &
-                             ( gg - bb ) * de_dz(k,j,i+1) + &
-                             ( gg - cc ) * de_dz(k,j+1,i) + &
-                             ( gg - dd ) * de_dz(k,j+1,i+1) &
-                           ) / ( 3.0 * gg )
-
-             IF ( ( k+1 == nzt+1 )  .OR.  ( k == nzb ) )  THEN
-                de_dz_int = de_dz_int_l
-             ELSE
-                de_dz_int_u = ( ( gg - aa ) * de_dz(k+1,j,i)   + &
-                                ( gg - bb ) * de_dz(k+1,j,i+1) + &
-                                ( gg - cc ) * de_dz(k+1,j+1,i) + &
-                                ( gg - dd ) * de_dz(k+1,j+1,i+1) &
-                              ) / ( 3.0 * gg )
-                de_dz_int = de_dz_int_l + ( particles(n)%z - zu(k) ) / dz * &
-                                          ( de_dz_int_u - de_dz_int_l )
-             ENDIF
-
-!
-!--          Interpolate the dissipation of TKE
-             diss_int_l = ( ( gg - aa ) * diss(k,j,i)   + &
-                            ( gg - bb ) * diss(k,j,i+1) + &
-                            ( gg - cc ) * diss(k,j+1,i) + &
-                            ( gg - dd ) * diss(k,j+1,i+1) &
-                           ) / ( 3.0 * gg )
-
-             IF ( k+1 == nzt+1 )  THEN
-                diss_int = diss_int_l
-             ELSE
-                diss_int_u = ( ( gg - aa ) * diss(k+1,j,i)   + &
-                               ( gg - bb ) * diss(k+1,j,i+1) + &
-                               ( gg - cc ) * diss(k+1,j+1,i) + &
-                               ( gg - dd ) * diss(k+1,j+1,i+1) &
-                              ) / ( 3.0 * gg )
-                diss_int = diss_int_l + ( particles(n)%z - zu(k) ) / dz * &
-                                        ( diss_int_u - diss_int_l )
-             ENDIF
+
+!
+!--             In case that there are buildings it has to be determined 
+!--             how many of the gridpoints defining the particle box are 
+!--             situated within a building
+!--             gp_outside_of_building(1): i,j,k
+!--             gp_outside_of_building(2): i,j+1,k
+!--             gp_outside_of_building(3): i,j,k+1
+!--             gp_outside_of_building(4): i,j+1,k+1
+!--             gp_outside_of_building(5): i+1,j,k
+!--             gp_outside_of_building(6): i+1,j+1,k
+!--             gp_outside_of_building(7): i+1,j,k+1
+!--             gp_outside_of_building(8): i+1,j+1,k+1
+           
+                gp_outside_of_building = 0
+                location = 0.0
+                num_gp = 0
+
+                IF ( k > nzb_s_inner(j,i)  .OR.  nzb_s_inner(j,i) == 0 )  THEN 
+                   num_gp = num_gp + 1
+                   gp_outside_of_building(1) = 1
+                   location(num_gp,1) = i * dx
+                   location(num_gp,2) = j * dx
+                   location(num_gp,3) = k * dz - 0.5 * dz
+                   ei(num_gp)     = e(k,j,i)
+                   dissi(num_gp)  = diss(k,j,i)
+                   de_dxi(num_gp) = de_dx(k,j,i)
+                   de_dyi(num_gp) = de_dy(k,j,i)
+                   de_dzi(num_gp) = de_dz(k,j,i)
+                ENDIF
+
+                IF ( k > nzb_s_inner(j+1,i)  .OR.  nzb_s_inner(j+1,i) == 0 ) &
+                THEN
+                   num_gp = num_gp + 1
+                   gp_outside_of_building(2) = 1
+                   location(num_gp,1) = i * dx
+                   location(num_gp,2) = (j+1) * dx
+                   location(num_gp,3) = k * dz - 0.5 * dz
+                   ei(num_gp)     = e(k,j+1,i)
+                   dissi(num_gp)  = diss(k,j+1,i)        
+                   de_dxi(num_gp) = de_dx(k,j+1,i)
+                   de_dyi(num_gp) = de_dy(k,j+1,i)
+                   de_dzi(num_gp) = de_dz(k,j+1,i)
+                ENDIF
+
+                IF ( k+1 > nzb_s_inner(j,i)  .OR.  nzb_s_inner(j,i) == 0 )  THEN
+                   num_gp = num_gp + 1
+                   gp_outside_of_building(3) = 1
+                   location(num_gp,1) = i * dx
+                   location(num_gp,2) = j * dy
+                   location(num_gp,3) = (k+1) * dz - 0.5 * dz
+                   ei(num_gp)     = e(k+1,j,i)
+                   dissi(num_gp)  = diss(k+1,j,i)        
+                   de_dxi(num_gp) = de_dx(k+1,j,i)
+                   de_dyi(num_gp) = de_dy(k+1,j,i)
+                   de_dzi(num_gp) = de_dz(k+1,j,i)
+                ENDIF
+
+                IF ( k+1 > nzb_s_inner(j+1,i)  .OR.  nzb_s_inner(j+1,i) == 0 ) &
+                THEN
+                   num_gp = num_gp + 1
+                   gp_outside_of_building(4) = 1
+                   location(num_gp,1) = i * dx
+                   location(num_gp,2) = (j+1) * dy
+                   location(num_gp,3) = (k+1) * dz - 0.5 * dz
+                   ei(num_gp)     = e(k+1,j+1,i)
+                   dissi(num_gp)  = diss(k+1,j+1,i)        
+                   de_dxi(num_gp) = de_dx(k+1,j+1,i)
+                   de_dyi(num_gp) = de_dy(k+1,j+1,i)
+                   de_dzi(num_gp) = de_dz(k+1,j+1,i)
+                ENDIF
+ 
+                IF ( k > nzb_s_inner(j,i+1)  .OR.  nzb_s_inner(j,i+1) == 0 ) &
+                THEN
+                   num_gp = num_gp + 1
+                   gp_outside_of_building(5) = 1
+                   location(num_gp,1) = (i+1) * dx
+                   location(num_gp,2) = j * dy
+                   location(num_gp,3) = k * dz - 0.5 * dz
+                   ei(num_gp)     = e(k,j,i+1)
+                   dissi(num_gp)  = diss(k,j,i+1) 
+                   de_dxi(num_gp) = de_dx(k,j,i+1)
+                   de_dyi(num_gp) = de_dy(k,j,i+1)
+                   de_dzi(num_gp) = de_dz(k,j,i+1)
+                ENDIF
+
+                IF ( k > nzb_s_inner(j+1,i+1) .OR. nzb_s_inner(j+1,i+1) == 0 ) &
+                THEN
+                   num_gp = num_gp + 1
+                   gp_outside_of_building(6) = 1
+                   location(num_gp,1) = (i+1) * dx
+                   location(num_gp,2) = (j+1) * dy
+                   location(num_gp,3) = k * dz - 0.5 * dz
+                   ei(num_gp)     = e(k,j+1,i+1)
+                   dissi(num_gp)  = diss(k,j+1,i+1) 
+                   de_dxi(num_gp) = de_dx(k,j+1,i+1)
+                   de_dyi(num_gp) = de_dy(k,j+1,i+1)
+                   de_dzi(num_gp) = de_dz(k,j+1,i+1)
+                ENDIF
+
+                IF ( k+1 > nzb_s_inner(j,i+1)  .OR.  nzb_s_inner(j,i+1) == 0 ) &
+                THEN
+                   num_gp = num_gp + 1
+                   gp_outside_of_building(7) = 1
+                   location(num_gp,1) = (i+1) * dx
+                   location(num_gp,2) = j * dy
+                   location(num_gp,3) = (k+1) * dz - 0.5 * dz
+                   ei(num_gp)     = e(k+1,j,i+1)
+                   dissi(num_gp)  = diss(k+1,j,i+1) 
+                   de_dxi(num_gp) = de_dx(k+1,j,i+1)
+                   de_dyi(num_gp) = de_dy(k+1,j,i+1)
+                   de_dzi(num_gp) = de_dz(k+1,j,i+1)
+                ENDIF
+
+                IF ( k+1 > nzb_s_inner(j+1,i+1) .OR. nzb_s_inner(j+1,i+1) == 0)&
+                THEN
+                   num_gp = num_gp + 1
+                   gp_outside_of_building(8) = 1
+                   location(num_gp,1) = (i+1) * dx
+                   location(num_gp,2) = (j+1) * dy
+                   location(num_gp,3) = (k+1) * dz - 0.5 * dz
+                   ei(num_gp)     = e(k+1,j+1,i+1)
+                   dissi(num_gp)  = diss(k+1,j+1,i+1) 
+                   de_dxi(num_gp) = de_dx(k+1,j+1,i+1)
+                   de_dyi(num_gp) = de_dy(k+1,j+1,i+1)
+                   de_dzi(num_gp) = de_dz(k+1,j+1,i+1)
+                ENDIF
+
+!
+!--             If all gridpoints are situated outside of a building, then the 
+!--             ordinary interpolation scheme can be used.
+                IF ( num_gp == 8 )  THEN
+
+                   x  = particles(n)%x - i * dx
+                   y  = particles(n)%y - j * dy
+                   aa = x**2          + y**2
+                   bb = ( dx - x )**2 + y**2
+                   cc = x**2          + ( dy - y )**2
+                   dd = ( dx - x )**2 + ( dy - y )**2
+                   gg = aa + bb + cc + dd
+
+                   e_int_l = (( gg-aa ) * e(k,j,i)   + ( gg-bb ) * e(k,j,i+1) &
+                            + ( gg-cc ) * e(k,j+1,i) + ( gg-dd ) * e(k,j+1,i+1)&
+                             ) / ( 3.0 * gg )
+
+                   IF ( k+1 == nzt+1 )  THEN
+                      e_int = e_int_l
+                   ELSE
+                      e_int_u = ( ( gg - aa ) * e(k+1,j,i)   + &
+                                  ( gg - bb ) * e(k+1,j,i+1) + &
+                                  ( gg - cc ) * e(k+1,j+1,i) + &
+                                  ( gg - dd ) * e(k+1,j+1,i+1) &
+                                ) / ( 3.0 * gg )
+                      e_int = e_int_l + ( particles(n)%z - zu(k) ) / dz * &
+                                        ( e_int_u - e_int_l )
+                   ENDIF
+
+!
+!--                Interpolate the TKE gradient along x (adopt incides i,j,k
+!--                and all position variables from above (TKE))
+                   de_dx_int_l = ( ( gg - aa ) * de_dx(k,j,i)   + &
+                                   ( gg - bb ) * de_dx(k,j,i+1) + &
+                                   ( gg - cc ) * de_dx(k,j+1,i) + &
+                                   ( gg - dd ) * de_dx(k,j+1,i+1) &
+                                 ) / ( 3.0 * gg )
+
+                   IF ( ( k+1 == nzt+1 )  .OR.  ( k == nzb ) )  THEN
+                      de_dx_int = de_dx_int_l
+                   ELSE
+                      de_dx_int_u = ( ( gg - aa ) * de_dx(k+1,j,i)   + &
+                                      ( gg - bb ) * de_dx(k+1,j,i+1) + &
+                                      ( gg - cc ) * de_dx(k+1,j+1,i) + &
+                                      ( gg - dd ) * de_dx(k+1,j+1,i+1) &
+                                    ) / ( 3.0 * gg )
+                      de_dx_int = de_dx_int_l + ( particles(n)%z - zu(k) ) / &
+                                              dz * ( de_dx_int_u - de_dx_int_l )
+                   ENDIF
+
+!
+!--                Interpolate the TKE gradient along y
+                   de_dy_int_l = ( ( gg - aa ) * de_dy(k,j,i)   + &
+                                   ( gg - bb ) * de_dy(k,j,i+1) + &
+                                   ( gg - cc ) * de_dy(k,j+1,i) + &
+                                   ( gg - dd ) * de_dy(k,j+1,i+1) &
+                                 ) / ( 3.0 * gg )
+                   IF ( ( k+1 == nzt+1 )  .OR.  ( k == nzb ) )  THEN
+                      de_dy_int = de_dy_int_l
+                   ELSE
+                      de_dy_int_u = ( ( gg - aa ) * de_dy(k+1,j,i)   + &
+                                      ( gg - bb ) * de_dy(k+1,j,i+1) + &
+                                      ( gg - cc ) * de_dy(k+1,j+1,i) + &
+                                      ( gg - dd ) * de_dy(k+1,j+1,i+1) &
+                                    ) / ( 3.0 * gg )
+                      de_dy_int = de_dy_int_l + ( particles(n)%z - zu(k) ) / &
+                                              dz * ( de_dy_int_u - de_dy_int_l )
+                   ENDIF
+
+!
+!--                Interpolate the TKE gradient along z
+                   IF ( particles(n)%z < 0.5 * dz )  THEN
+                      de_dz_int = 0.0
+                   ELSE
+                      de_dz_int_l = ( ( gg - aa ) * de_dz(k,j,i)   + &
+                                      ( gg - bb ) * de_dz(k,j,i+1) + &
+                                      ( gg - cc ) * de_dz(k,j+1,i) + &
+                                      ( gg - dd ) * de_dz(k,j+1,i+1) &
+                                    ) / ( 3.0 * gg )
+
+                      IF ( ( k+1 == nzt+1 )  .OR.  ( k == nzb ) )  THEN
+                         de_dz_int = de_dz_int_l
+                      ELSE
+                         de_dz_int_u = ( ( gg - aa ) * de_dz(k+1,j,i)   + &
+                                         ( gg - bb ) * de_dz(k+1,j,i+1) + &
+                                         ( gg - cc ) * de_dz(k+1,j+1,i) + &
+                                         ( gg - dd ) * de_dz(k+1,j+1,i+1) &
+                                       ) / ( 3.0 * gg )
+                         de_dz_int = de_dz_int_l + ( particles(n)%z - zu(k) ) /&
+                                              dz * ( de_dz_int_u - de_dz_int_l )
+                      ENDIF
+                   ENDIF
+
+!
+!--                Interpolate the dissipation of TKE
+                   diss_int_l = ( ( gg - aa ) * diss(k,j,i)   + &
+                                  ( gg - bb ) * diss(k,j,i+1) + &
+                                  ( gg - cc ) * diss(k,j+1,i) + &
+                                  ( gg - dd ) * diss(k,j+1,i+1) &
+                                ) / ( 3.0 * gg )
+
+                   IF ( k+1 == nzt+1 )  THEN
+                      diss_int = diss_int_l
+                   ELSE
+                      diss_int_u = ( ( gg - aa ) * diss(k+1,j,i)   + &
+                                     ( gg - bb ) * diss(k+1,j,i+1) + &
+                                     ( gg - cc ) * diss(k+1,j+1,i) + &
+                                     ( gg - dd ) * diss(k+1,j+1,i+1) &
+                                   ) / ( 3.0 * gg )
+                      diss_int = diss_int_l + ( particles(n)%z - zu(k) ) / dz *&
+                                              ( diss_int_u - diss_int_l )
+                   ENDIF
+
+                ELSE
+
+!
+!--                If wall between gridpoint 1 and gridpoint 5, then
+!--                Neumann boundary condition has to be applied
+                   IF ( gp_outside_of_building(1) == 1  .AND. &
+                        gp_outside_of_building(5) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx + 0.5 * dx
+                      location(num_gp,2) = j * dy
+                      location(num_gp,3) = k * dz - 0.5 * dz
+                      ei(num_gp)     = e(k,j,i)
+                      dissi(num_gp)  = diss(k,j,i)
+                      de_dxi(num_gp) = 0.0
+                      de_dyi(num_gp) = de_dy(k,j,i)
+                      de_dzi(num_gp) = de_dz(k,j,i)                     
+                   ENDIF 
+   
+                   IF ( gp_outside_of_building(5) == 1  .AND. &
+                      gp_outside_of_building(1) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx + 0.5 * dx
+                      location(num_gp,2) = j * dy
+                      location(num_gp,3) = k * dz - 0.5 * dz
+                      ei(num_gp)     = e(k,j,i+1)
+                      dissi(num_gp)  = diss(k,j,i+1)
+                      de_dxi(num_gp) = 0.0
+                      de_dyi(num_gp) = de_dy(k,j,i+1)
+                      de_dzi(num_gp) = de_dz(k,j,i+1)
+                   ENDIF
+
+!
+!--                If wall between gridpoint 5 and gridpoint 6, then
+!--                then Neumann boundary condition has to be applied
+                   IF ( gp_outside_of_building(5) == 1  .AND. &
+                        gp_outside_of_building(6) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = (i+1) * dx
+                      location(num_gp,2) = j * dy + 0.5 * dy
+                      location(num_gp,3) = k * dz - 0.5 * dz
+                      ei(num_gp)     = e(k,j,i+1)
+                      dissi(num_gp)  = diss(k,j,i+1)
+                      de_dxi(num_gp) = de_dx(k,j,i+1)
+                      de_dyi(num_gp) = 0.0
+                      de_dzi(num_gp) = de_dz(k,j,i+1)
+                   ENDIF
+
+                   IF ( gp_outside_of_building(6) == 1  .AND. &
+                        gp_outside_of_building(5) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = (i+1) * dx
+                      location(num_gp,2) = j * dy + 0.5 * dy
+                      location(num_gp,3) = k * dz - 0.5 * dz
+                      ei(num_gp)     = e(k,j+1,i+1)
+                      dissi(num_gp)  = diss(k,j+1,i+1)
+                      de_dxi(num_gp) = de_dx(k,j+1,i+1)
+                      de_dyi(num_gp) = 0.0
+                      de_dzi(num_gp) = de_dz(k,j+1,i+1)
+                   ENDIF
+
+!
+!--                If wall between gridpoint 2 and gridpoint 6, then
+!--                Neumann boundary condition has to be applied
+                   IF ( gp_outside_of_building(2) == 1  .AND. &
+                        gp_outside_of_building(6) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx + 0.5 * dx
+                      location(num_gp,2) = (j+1) * dy
+                      location(num_gp,3) = k * dz - 0.5 * dz
+                      ei(num_gp)     = e(k,j+1,i)
+                      dissi(num_gp)  = diss(k,j+1,i)
+                      de_dxi(num_gp) = 0.0
+                      de_dyi(num_gp) = de_dy(k,j+1,i)
+                      de_dzi(num_gp) = de_dz(k,j+1,i)                     
+                   ENDIF 
+   
+                   IF ( gp_outside_of_building(6) == 1  .AND. &
+                        gp_outside_of_building(2) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx + 0.5 * dx
+                      location(num_gp,2) = (j+1) * dy
+                      location(num_gp,3) = k * dz - 0.5 * dz
+                      ei(num_gp)     = e(k,j+1,i+1)
+                      dissi(num_gp)  = diss(k,j+1,i+1)
+                      de_dxi(num_gp) = 0.0
+                      de_dyi(num_gp) = de_dy(k,j+1,i+1)
+                      de_dzi(num_gp) = de_dz(k,j+1,i+1)
+                   ENDIF
+
+!
+!--                If wall between gridpoint 1 and gridpoint 2, then
+!--                Neumann boundary condition has to be applied
+                   IF ( gp_outside_of_building(1) == 1  .AND. &
+                        gp_outside_of_building(2) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx
+                      location(num_gp,2) = j * dy + 0.5 * dy
+                      location(num_gp,3) = k * dz - 0.5 * dz
+                      ei(num_gp)     = e(k,j,i)
+                      dissi(num_gp)  = diss(k,j,i)
+                      de_dxi(num_gp) = de_dx(k,j,i)
+                      de_dyi(num_gp) = 0.0
+                      de_dzi(num_gp) = de_dz(k,j,i)
+                   ENDIF
+
+                   IF ( gp_outside_of_building(2) == 1  .AND. &
+                        gp_outside_of_building(1) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx
+                      location(num_gp,2) = j * dy + 0.5 * dy
+                      location(num_gp,3) = k * dz - 0.5 * dz
+                      ei(num_gp)     = e(k,j+1,i)
+                      dissi(num_gp)  = diss(k,j+1,i)
+                      de_dxi(num_gp) = de_dx(k,j+1,i)
+                      de_dyi(num_gp) = 0.0
+                      de_dzi(num_gp) = de_dz(k,j+1,i)
+                   ENDIF
+
+!
+!--                If wall between gridpoint 3 and gridpoint 7, then
+!--                Neumann boundary condition has to be applied
+                   IF ( gp_outside_of_building(3) == 1  .AND. &
+                        gp_outside_of_building(7) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx + 0.5 * dx
+                      location(num_gp,2) = j * dy
+                      location(num_gp,3) = k * dz + 0.5 * dz
+                      ei(num_gp)     = e(k+1,j,i)
+                      dissi(num_gp)  = diss(k+1,j,i)
+                      de_dxi(num_gp) = 0.0
+                      de_dyi(num_gp) = de_dy(k+1,j,i)
+                      de_dzi(num_gp) = de_dz(k+1,j,i)                     
+                   ENDIF 
+   
+                   IF ( gp_outside_of_building(7) == 1  .AND. &
+                        gp_outside_of_building(3) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx + 0.5 * dx
+                      location(num_gp,2) = j * dy
+                      location(num_gp,3) = k * dz + 0.5 * dz
+                      ei(num_gp)     = e(k+1,j,i+1)
+                      dissi(num_gp)  = diss(k+1,j,i+1)
+                      de_dxi(num_gp) = 0.0
+                      de_dyi(num_gp) = de_dy(k+1,j,i+1)
+                      de_dzi(num_gp) = de_dz(k+1,j,i+1)
+                   ENDIF
+
+!
+!--                If wall between gridpoint 7 and gridpoint 8, then
+!--                Neumann boundary condition has to be applied
+                   IF ( gp_outside_of_building(7) == 1  .AND. &
+                        gp_outside_of_building(8) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = (i+1) * dx
+                      location(num_gp,2) = j * dy + 0.5 * dy
+                      location(num_gp,3) = k * dz + 0.5 * dz
+                      ei(num_gp)     = e(k+1,j,i+1)
+                      dissi(num_gp)  = diss(k+1,j,i+1)
+                      de_dxi(num_gp) = de_dx(k+1,j,i+1)
+                      de_dyi(num_gp) = 0.0
+                      de_dzi(num_gp) = de_dz(k+1,j,i+1)
+                   ENDIF
+
+                   IF ( gp_outside_of_building(8) == 1  .AND. &
+                        gp_outside_of_building(7) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = (i+1) * dx
+                      location(num_gp,2) = j * dy + 0.5 * dy
+                      location(num_gp,3) = k * dz + 0.5 * dz
+                      ei(num_gp)     = e(k+1,j+1,i+1)
+                      dissi(num_gp)  = diss(k+1,j+1,i+1)
+                      de_dxi(num_gp) = de_dx(k+1,j+1,i+1)
+                      de_dyi(num_gp) = 0.0
+                      de_dzi(num_gp) = de_dz(k+1,j+1,i+1)
+                   ENDIF
+
+!
+!--                If wall between gridpoint 4 and gridpoint 8, then
+!--                Neumann boundary condition has to be applied
+                   IF ( gp_outside_of_building(4) == 1  .AND. &
+                        gp_outside_of_building(8) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx + 0.5 * dx
+                      location(num_gp,2) = (j+1) * dy
+                      location(num_gp,3) = k * dz + 0.5 * dz
+                      ei(num_gp)     = e(k+1,j+1,i)
+                      dissi(num_gp)  = diss(k+1,j+1,i)
+                      de_dxi(num_gp) = 0.0
+                      de_dyi(num_gp) = de_dy(k+1,j+1,i)
+                      de_dzi(num_gp) = de_dz(k+1,j+1,i)                     
+                   ENDIF 
+   
+                   IF ( gp_outside_of_building(8) == 1  .AND. &
+                        gp_outside_of_building(4) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx + 0.5 * dx
+                      location(num_gp,2) = (j+1) * dy
+                      location(num_gp,3) = k * dz + 0.5 * dz
+                      ei(num_gp)     = e(k+1,j+1,i+1)
+                      dissi(num_gp)  = diss(k+1,j+1,i+1)
+                      de_dxi(num_gp) = 0.0
+                      de_dyi(num_gp) = de_dy(k+1,j+1,i+1)
+                      de_dzi(num_gp) = de_dz(k+1,j+1,i+1)
+                   ENDIF
+
+!
+!--                If wall between gridpoint 3 and gridpoint 4, then
+!--                Neumann boundary condition has to be applied
+                   IF ( gp_outside_of_building(3) == 1  .AND. &
+                        gp_outside_of_building(4) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx
+                      location(num_gp,2) = j * dy + 0.5 * dy
+                      location(num_gp,3) = k * dz + 0.5 * dz
+                      ei(num_gp)     = e(k+1,j,i)
+                      dissi(num_gp)  = diss(k+1,j,i)
+                      de_dxi(num_gp) = de_dx(k+1,j,i)
+                      de_dyi(num_gp) = 0.0
+                      de_dzi(num_gp) = de_dz(k+1,j,i)
+                   ENDIF
+
+                   IF ( gp_outside_of_building(4) == 1  .AND. &
+                        gp_outside_of_building(3) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx
+                      location(num_gp,2) = j * dy + 0.5 * dy
+                      location(num_gp,3) = k * dz + 0.5 * dz
+                      ei(num_gp)     = e(k+1,j+1,i)
+                      dissi(num_gp)  = diss(k+1,j+1,i)
+                      de_dxi(num_gp) = de_dx(k+1,j+1,i)
+                      de_dyi(num_gp) = 0.0
+                      de_dzi(num_gp) = de_dz(k+1,j+1,i)
+                   ENDIF
+
+!
+!--                If wall between gridpoint 1 and gridpoint 3, then
+!--                Neumann boundary condition has to be applied
+!--                (only one case as only building beneath is possible)
+                   IF ( gp_outside_of_building(1) == 1  .AND. &
+                        gp_outside_of_building(3) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx
+                      location(num_gp,2) = j * dy
+                      location(num_gp,3) = k * dz
+                      ei(num_gp)     = e(k+1,j,i)
+                      dissi(num_gp)  = diss(k+1,j,i)
+                      de_dxi(num_gp) = de_dx(k+1,j,i)
+                      de_dyi(num_gp) = de_dy(k+1,j,i)
+                      de_dzi(num_gp) = 0.0
+                   ENDIF
+ 
+!
+!--                If wall between gridpoint 5 and gridpoint 7, then
+!--                Neumann boundary condition has to be applied
+!--                (only one case as only building beneath is possible)
+                   IF ( gp_outside_of_building(5) == 1  .AND. &
+                        gp_outside_of_building(7) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = (i+1) * dx
+                      location(num_gp,2) = j * dy
+                      location(num_gp,3) = k * dz
+                      ei(num_gp)     = e(k+1,j,i+1)
+                      dissi(num_gp)  = diss(k+1,j,i+1)
+                      de_dxi(num_gp) = de_dx(k+1,j,i+1)
+                      de_dyi(num_gp) = de_dy(k+1,j,i+1)
+                      de_dzi(num_gp) = 0.0
+                   ENDIF
+
+!
+!--                If wall between gridpoint 2 and gridpoint 4, then
+!--                Neumann boundary condition has to be applied
+!--                (only one case as only building beneath is possible)
+                   IF ( gp_outside_of_building(2) == 1  .AND. &
+                        gp_outside_of_building(4) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = i * dx
+                      location(num_gp,2) = (j+1) * dy
+                      location(num_gp,3) = k * dz
+                      ei(num_gp)     = e(k+1,j+1,i)
+                      dissi(num_gp)  = diss(k+1,j+1,i)
+                      de_dxi(num_gp) = de_dx(k+1,j+1,i)
+                      de_dyi(num_gp) = de_dy(k+1,j+1,i)
+                      de_dzi(num_gp) = 0.0
+                   ENDIF
+
+!
+!--                If wall between gridpoint 6 and gridpoint 8, then
+!--                Neumann boundary condition has to be applied
+!--                (only one case as only building beneath is possible)
+                   IF ( gp_outside_of_building(6) == 1  .AND. &
+                        gp_outside_of_building(8) == 0 )  THEN
+                      num_gp = num_gp + 1
+                      location(num_gp,1) = (i+1) * dx
+                      location(num_gp,2) = (j+1) * dy
+                      location(num_gp,3) = k * dz
+                      ei(num_gp)     = e(k+1,j+1,i+1)
+                      dissi(num_gp)  = diss(k+1,j+1,i+1)
+                      de_dxi(num_gp) = de_dx(k+1,j+1,i+1)
+                      de_dyi(num_gp) = de_dy(k+1,j+1,i+1)
+                      de_dzi(num_gp) = 0.0
+                   ENDIF
+
+!
+!--                Carry out the interpolation
+                   IF ( num_gp == 1 )  THEN
+!
+!--                   If only one of the gridpoints is situated outside of the 
+!--                   building, it follows that the values at the particle 
+!--                   location are the same as the gridpoint values
+                      e_int = ei(num_gp)
+
+                   ELSE IF ( num_gp > 1 )  THEN
+
+                      d_sum = 0.0
+!
+!--                   Evaluation of the distances between the gridpoints 
+!--                   contributing to the interpolated values, and the particle 
+!--                   location
+                      DO agp = 1, num_gp
+                         d_gp_pl(agp) = ( particles(n)%x-location(agp,1) )**2  &
+                                      + ( particles(n)%y-location(agp,2) )**2  &
+                                      + ( particles(n)%z-location(agp,3) )**2
+                         d_sum        = d_sum + d_gp_pl(agp)
+                      ENDDO
+
+!
+!--                   Finally the interpolation can be carried out
+                      e_int     = 0.0
+                      diss_int  = 0.0
+                      de_dx_int = 0.0
+                      de_dy_int = 0.0
+                      de_dz_int = 0.0
+                      DO agp = 1, num_gp
+                         e_int     = e_int     + ( d_sum - d_gp_pl(agp) ) * &
+                                                ei(agp) / ( (num_gp-1) * d_sum )
+                         diss_int  = diss_int  + ( d_sum - d_gp_pl(agp) ) * &
+                                             dissi(agp) / ( (num_gp-1) * d_sum )
+                         de_dx_int = de_dx_int + ( d_sum - d_gp_pl(agp) ) * &
+                                            de_dxi(agp) / ( (num_gp-1) * d_sum )
+                         de_dy_int = de_dy_int + ( d_sum - d_gp_pl(agp) ) * &
+                                            de_dyi(agp) / ( (num_gp-1) * d_sum )
+                         de_dz_int = de_dz_int + ( d_sum - d_gp_pl(agp) ) * &
+                                            de_dzi(agp) / ( (num_gp-1) * d_sum )
+                      ENDDO
+
+                   ENDIF
+
+                ENDIF
+
+             ENDIF  
 
 !
